#include "qwayland-server-plasma-effects.h"

QT_BEGIN_NAMESPACE

namespace QtWaylandServer {
    org_kde_plasma_effects::org_kde_plasma_effects(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    org_kde_plasma_effects::org_kde_plasma_effects(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    org_kde_plasma_effects::org_kde_plasma_effects()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    org_kde_plasma_effects::~org_kde_plasma_effects()
    {
    }

    void org_kde_plasma_effects::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    org_kde_plasma_effects::Resource *org_kde_plasma_effects::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    org_kde_plasma_effects::Resource *org_kde_plasma_effects::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void org_kde_plasma_effects::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::org_kde_plasma_effects_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    org_kde_plasma_effects::Resource *org_kde_plasma_effects::effects_allocate()
    {
        return new Resource;
    }

    void org_kde_plasma_effects::effects_bind_resource(Resource *)
    {
    }

    void org_kde_plasma_effects::effects_destroy_resource(Resource *)
    {
    }

    void org_kde_plasma_effects::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        org_kde_plasma_effects *that = static_cast<org_kde_plasma_effects *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void org_kde_plasma_effects::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        org_kde_plasma_effects *that = resource->effects_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->effects_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    org_kde_plasma_effects::Resource *org_kde_plasma_effects::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Resource *resource = effects_allocate();
        resource->effects_object = this;

        struct ::wl_resource *handle = wl_resource_create(client, &::org_kde_plasma_effects_interface, version, id);
        wl_resource_set_implementation(handle, &m_org_kde_plasma_effects_interface, resource, destroy_func);
        resource->handle = handle;
        effects_bind_resource(resource);
        return resource;
    }

    const struct ::org_kde_plasma_effects_interface org_kde_plasma_effects::m_org_kde_plasma_effects_interface = {
        org_kde_plasma_effects::handle_slide,
        org_kde_plasma_effects::handle_set_blur_behind_region,
        org_kde_plasma_effects::handle_set_contrast_region
    };

    void org_kde_plasma_effects::effects_slide(Resource *, struct ::wl_resource *, struct ::wl_resource *, uint32_t , int32_t , int32_t )
    {
    }

    void org_kde_plasma_effects::effects_set_blur_behind_region(Resource *, struct ::wl_resource *, struct ::wl_resource *)
    {
    }

    void org_kde_plasma_effects::effects_set_contrast_region(Resource *, struct ::wl_resource *, struct ::wl_resource *, uint32_t , uint32_t , uint32_t )
    {
    }


    void org_kde_plasma_effects::handle_slide(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        struct ::wl_resource *surface,
        uint32_t from,
        int32_t x,
        int32_t y)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_effects *>(r->effects_object)->effects_slide(
            r,
            output,
            surface,
            from,
            x,
            y);
    }

    void org_kde_plasma_effects::handle_set_blur_behind_region(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *surface,
        struct ::wl_resource *region)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_effects *>(r->effects_object)->effects_set_blur_behind_region(
            r,
            surface,
            region);
    }

    void org_kde_plasma_effects::handle_set_contrast_region(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *surface,
        struct ::wl_resource *region,
        uint32_t contrast,
        uint32_t intensity,
        uint32_t saturation)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_effects *>(r->effects_object)->effects_set_contrast_region(
            r,
            surface,
            region,
            contrast,
            intensity,
            saturation);
    }
}

QT_END_NAMESPACE
