#include "qwayland-server-plasma-shell.h"

QT_BEGIN_NAMESPACE

namespace QtWaylandServer {
    org_kde_plasma_shell::org_kde_plasma_shell(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    org_kde_plasma_shell::org_kde_plasma_shell(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    org_kde_plasma_shell::org_kde_plasma_shell()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    org_kde_plasma_shell::~org_kde_plasma_shell()
    {
    }

    void org_kde_plasma_shell::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    org_kde_plasma_shell::Resource *org_kde_plasma_shell::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    org_kde_plasma_shell::Resource *org_kde_plasma_shell::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void org_kde_plasma_shell::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::org_kde_plasma_shell_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    org_kde_plasma_shell::Resource *org_kde_plasma_shell::shell_allocate()
    {
        return new Resource;
    }

    void org_kde_plasma_shell::shell_bind_resource(Resource *)
    {
    }

    void org_kde_plasma_shell::shell_destroy_resource(Resource *)
    {
    }

    void org_kde_plasma_shell::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        org_kde_plasma_shell *that = static_cast<org_kde_plasma_shell *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void org_kde_plasma_shell::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        org_kde_plasma_shell *that = resource->shell_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->shell_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    org_kde_plasma_shell::Resource *org_kde_plasma_shell::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Resource *resource = shell_allocate();
        resource->shell_object = this;

        struct ::wl_resource *handle = wl_resource_create(client, &::org_kde_plasma_shell_interface, version, id);
        wl_resource_set_implementation(handle, &m_org_kde_plasma_shell_interface, resource, destroy_func);
        resource->handle = handle;
        shell_bind_resource(resource);
        return resource;
    }

    const struct ::org_kde_plasma_shell_interface org_kde_plasma_shell::m_org_kde_plasma_shell_interface = {
        org_kde_plasma_shell::handle_get_surface,
        org_kde_plasma_shell::handle_desktop_ready,
        org_kde_plasma_shell::handle_present
    };

    void org_kde_plasma_shell::shell_get_surface(Resource *, uint32_t, struct ::wl_resource *)
    {
    }

    void org_kde_plasma_shell::shell_desktop_ready(Resource *)
    {
    }

    void org_kde_plasma_shell::shell_present(Resource *, wl_array *)
    {
    }


    void org_kde_plasma_shell::handle_get_surface(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t id,
        struct ::wl_resource *surface)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_shell *>(r->shell_object)->shell_get_surface(
            r,
            id,
            surface);
    }

    void org_kde_plasma_shell::handle_desktop_ready(
        ::wl_client *client,
        struct wl_resource *resource)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_shell *>(r->shell_object)->shell_desktop_ready(
            r);
    }

    void org_kde_plasma_shell::handle_present(
        ::wl_client *client,
        struct wl_resource *resource,
        wl_array *surfaces)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_shell *>(r->shell_object)->shell_present(
            r,
            surfaces);
    }

    void org_kde_plasma_shell::send_loaded()
    {
        send_loaded(
            m_resource->handle);
    }

    void org_kde_plasma_shell::send_loaded(struct ::wl_resource *resource)
    {
        org_kde_plasma_shell_send_loaded(
            resource);
    }


    org_kde_plasma_surface::org_kde_plasma_surface(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    org_kde_plasma_surface::org_kde_plasma_surface(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    org_kde_plasma_surface::org_kde_plasma_surface()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    org_kde_plasma_surface::~org_kde_plasma_surface()
    {
    }

    void org_kde_plasma_surface::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    org_kde_plasma_surface::Resource *org_kde_plasma_surface::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    org_kde_plasma_surface::Resource *org_kde_plasma_surface::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void org_kde_plasma_surface::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::org_kde_plasma_surface_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    org_kde_plasma_surface::Resource *org_kde_plasma_surface::surface_allocate()
    {
        return new Resource;
    }

    void org_kde_plasma_surface::surface_bind_resource(Resource *)
    {
    }

    void org_kde_plasma_surface::surface_destroy_resource(Resource *)
    {
    }

    void org_kde_plasma_surface::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        org_kde_plasma_surface *that = static_cast<org_kde_plasma_surface *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void org_kde_plasma_surface::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        org_kde_plasma_surface *that = resource->surface_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->surface_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    org_kde_plasma_surface::Resource *org_kde_plasma_surface::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Resource *resource = surface_allocate();
        resource->surface_object = this;

        struct ::wl_resource *handle = wl_resource_create(client, &::org_kde_plasma_surface_interface, version, id);
        wl_resource_set_implementation(handle, &m_org_kde_plasma_surface_interface, resource, destroy_func);
        resource->handle = handle;
        surface_bind_resource(resource);
        return resource;
    }

    const struct ::org_kde_plasma_surface_interface org_kde_plasma_surface::m_org_kde_plasma_surface_interface = {
        org_kde_plasma_surface::handle_destroy,
        org_kde_plasma_surface::handle_set_output,
        org_kde_plasma_surface::handle_set_position,
        org_kde_plasma_surface::handle_set_role,
        org_kde_plasma_surface::handle_set_flags,
        org_kde_plasma_surface::handle_set_screen_edge
    };

    void org_kde_plasma_surface::surface_destroy(Resource *)
    {
    }

    void org_kde_plasma_surface::surface_set_output(Resource *, struct ::wl_resource *)
    {
    }

    void org_kde_plasma_surface::surface_set_position(Resource *, int32_t , int32_t )
    {
    }

    void org_kde_plasma_surface::surface_set_role(Resource *, uint32_t )
    {
    }

    void org_kde_plasma_surface::surface_set_flags(Resource *, uint32_t )
    {
    }

    void org_kde_plasma_surface::surface_set_screen_edge(Resource *, uint32_t )
    {
    }


    void org_kde_plasma_surface::handle_destroy(
        ::wl_client *client,
        struct wl_resource *resource)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_surface *>(r->surface_object)->surface_destroy(
            r);
    }

    void org_kde_plasma_surface::handle_set_output(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_surface *>(r->surface_object)->surface_set_output(
            r,
            output);
    }

    void org_kde_plasma_surface::handle_set_position(
        ::wl_client *client,
        struct wl_resource *resource,
        int32_t x,
        int32_t y)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_surface *>(r->surface_object)->surface_set_position(
            r,
            x,
            y);
    }

    void org_kde_plasma_surface::handle_set_role(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t role)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_surface *>(r->surface_object)->surface_set_role(
            r,
            role);
    }

    void org_kde_plasma_surface::handle_set_flags(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t flags)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_surface *>(r->surface_object)->surface_set_flags(
            r,
            flags);
    }

    void org_kde_plasma_surface::handle_set_screen_edge(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t screen_edge)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<org_kde_plasma_surface *>(r->surface_object)->surface_set_screen_edge(
            r,
            screen_edge);
    }
}

QT_END_NAMESPACE
