/* 
 * Copyright (C) 2014 Pier Luigi Fiorini
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

extern const struct wl_interface wl_output_interface;
extern const struct wl_interface wl_region_interface;
extern const struct wl_interface wl_surface_interface;

static const struct wl_interface *types[] = {
	&wl_output_interface,
	&wl_surface_interface,
	NULL,
	NULL,
	NULL,
	&wl_surface_interface,
	&wl_region_interface,
	&wl_surface_interface,
	&wl_region_interface,
	NULL,
	NULL,
	NULL,
};

static const struct wl_message org_kde_plasma_effects_requests[] = {
	{ "slide", "oouii", types + 0 },
	{ "set_blur_behind_region", "o?o", types + 5 },
	{ "set_contrast_region", "o?ouuu", types + 7 },
};

WL_EXPORT const struct wl_interface org_kde_plasma_effects_interface = {
	"org_kde_plasma_effects", 1,
	3, org_kde_plasma_effects_requests,
	0, NULL,
};

