#ifndef QT_WAYLAND_FULLSCREEN_SHELL
#define QT_WAYLAND_FULLSCREEN_SHELL

#include "wayland-fullscreen-shell-client-protocol.h"
#include <QByteArray>
#include <QString>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    class  _wl_fullscreen_shell
    {
    public:
        _wl_fullscreen_shell(struct ::wl_registry *registry, int id, int version);
        _wl_fullscreen_shell(struct ::_wl_fullscreen_shell *object);
        _wl_fullscreen_shell();

        virtual ~_wl_fullscreen_shell();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::_wl_fullscreen_shell *object);

        struct ::_wl_fullscreen_shell *object() { return m__wl_fullscreen_shell; }
        const struct ::_wl_fullscreen_shell *object() const { return m__wl_fullscreen_shell; }

        bool isInitialized() const;

        enum capability {
            capability_arbitrary_modes = 1, // compositor is capable of almost any output mode
            capability_cursor_plane = 2 // compositor has a seperate cursor plane
        };

        enum present_method {
            present_method_default = 0, // no preference, apply default policy
            present_method_center = 1, // center the surface on the output
            present_method_zoom = 2, // scale the surface, preserving aspect ratio, to the largest size that will fit on the output
            present_method_zoom_crop = 3, // scale the surface, preserving aspect ratio, to fully fill the output cropping if needed
            present_method_stretch = 4 // scale the surface to the size of the output ignoring aspect ratio
        };

        enum error {
            error_invalid_method = 0 // present_method is not known
        };

        void release();
        void present_surface(struct ::wl_surface *surface, uint32_t method, struct ::wl_output *output);
        struct ::_wl_fullscreen_shell_mode_feedback *present_surface_for_mode(struct ::wl_surface *surface, struct ::wl_output *output, int32_t framerate);

    protected:
        virtual void fullscreen_shell_capability(uint32_t capabilty);

    private:
        void init_listener();
        static const struct _wl_fullscreen_shell_listener m__wl_fullscreen_shell_listener;
        static void handle_capability(
            void *data,
            struct ::_wl_fullscreen_shell *object,
            uint32_t capabilty);
        struct ::_wl_fullscreen_shell *m__wl_fullscreen_shell;
    };

    class  _wl_fullscreen_shell_mode_feedback
    {
    public:
        _wl_fullscreen_shell_mode_feedback(struct ::wl_registry *registry, int id, int version);
        _wl_fullscreen_shell_mode_feedback(struct ::_wl_fullscreen_shell_mode_feedback *object);
        _wl_fullscreen_shell_mode_feedback();

        virtual ~_wl_fullscreen_shell_mode_feedback();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::_wl_fullscreen_shell_mode_feedback *object);

        struct ::_wl_fullscreen_shell_mode_feedback *object() { return m__wl_fullscreen_shell_mode_feedback; }
        const struct ::_wl_fullscreen_shell_mode_feedback *object() const { return m__wl_fullscreen_shell_mode_feedback; }

        bool isInitialized() const;

    protected:
        virtual void fullscreen_shell_mode_feedback_mode_successful();
        virtual void fullscreen_shell_mode_feedback_mode_failed();
        virtual void fullscreen_shell_mode_feedback_present_cancelled();

    private:
        void init_listener();
        static const struct _wl_fullscreen_shell_mode_feedback_listener m__wl_fullscreen_shell_mode_feedback_listener;
        static void handle_mode_successful(
            void *data,
            struct ::_wl_fullscreen_shell_mode_feedback *object);
        static void handle_mode_failed(
            void *data,
            struct ::_wl_fullscreen_shell_mode_feedback *object);
        static void handle_present_cancelled(
            void *data,
            struct ::_wl_fullscreen_shell_mode_feedback *object);
        struct ::_wl_fullscreen_shell_mode_feedback *m__wl_fullscreen_shell_mode_feedback;
    };
}

QT_END_NAMESPACE

#endif
