#include "qwayland-server-greenisland-screenshooter.h"

QT_BEGIN_NAMESPACE

namespace QtWaylandServer {
    greenisland_screenshooter::greenisland_screenshooter(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    greenisland_screenshooter::greenisland_screenshooter(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    greenisland_screenshooter::greenisland_screenshooter()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    greenisland_screenshooter::~greenisland_screenshooter()
    {
    }

    void greenisland_screenshooter::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void greenisland_screenshooter::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::greenisland_screenshooter_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::screenshooter_allocate()
    {
        return new Resource;
    }

    void greenisland_screenshooter::screenshooter_bind_resource(Resource *)
    {
    }

    void greenisland_screenshooter::screenshooter_destroy_resource(Resource *)
    {
    }

    void greenisland_screenshooter::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        greenisland_screenshooter *that = static_cast<greenisland_screenshooter *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void greenisland_screenshooter::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        greenisland_screenshooter *that = resource->screenshooter_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->screenshooter_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    greenisland_screenshooter::Resource *greenisland_screenshooter::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Resource *resource = screenshooter_allocate();
        resource->screenshooter_object = this;

        struct ::wl_resource *handle = wl_resource_create(client, &::greenisland_screenshooter_interface, version, id);
        wl_resource_set_implementation(handle, &m_greenisland_screenshooter_interface, resource, destroy_func);
        resource->handle = handle;
        screenshooter_bind_resource(resource);
        return resource;
    }

    const struct ::greenisland_screenshooter_interface greenisland_screenshooter::m_greenisland_screenshooter_interface = {
        greenisland_screenshooter::handle_shoot
    };

    void greenisland_screenshooter::screenshooter_shoot(Resource *, struct ::wl_resource *, struct ::wl_resource *)
    {
    }


    void greenisland_screenshooter::handle_shoot(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        struct ::wl_resource *buffer)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_screenshooter *>(r->screenshooter_object)->screenshooter_shoot(
            r,
            output,
            buffer);
    }

    void greenisland_screenshooter::send_done(int32_t result)
    {
        send_done(
            m_resource->handle,
            result);
    }

    void greenisland_screenshooter::send_done(struct ::wl_resource *resource, int32_t result)
    {
        greenisland_screenshooter_send_done(
            resource,
            result);
    }

}

QT_END_NAMESPACE
