/* 
 * Copyright (C) 2014 Jolla Ltd.
 * 
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 * 
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */

#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

extern const struct wl_interface greenisland_recorder_interface;
extern const struct wl_interface wl_buffer_interface;
extern const struct wl_interface wl_output_interface;

static const struct wl_interface *types[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	&greenisland_recorder_interface,
	&wl_output_interface,
	&wl_buffer_interface,
	&wl_buffer_interface,
	NULL,
	NULL,
	NULL,
	&wl_buffer_interface,
	&wl_buffer_interface,
};

static const struct wl_message greenisland_recorder_manager_requests[] = {
	{ "create_recorder", "no", types + 4 },
};

WL_EXPORT const struct wl_interface greenisland_recorder_manager_interface = {
	"greenisland_recorder_manager", 1,
	1, greenisland_recorder_manager_requests,
	0, NULL,
};

static const struct wl_message greenisland_recorder_requests[] = {
	{ "destroy", "", types + 0 },
	{ "record_frame", "o", types + 6 },
	{ "repaint", "", types + 0 },
};

static const struct wl_message greenisland_recorder_events[] = {
	{ "setup", "iiii", types + 0 },
	{ "frame", "oui", types + 7 },
	{ "failed", "io", types + 10 },
	{ "cancelled", "o", types + 12 },
};

WL_EXPORT const struct wl_interface greenisland_recorder_interface = {
	"greenisland_recorder", 1,
	3, greenisland_recorder_requests,
	4, greenisland_recorder_events,
};

