#include "qwayland-greenisland-recorder.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    greenisland_recorder_manager::greenisland_recorder_manager(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_recorder_manager::greenisland_recorder_manager(struct ::greenisland_recorder_manager *obj)
        : m_greenisland_recorder_manager(obj)
    {
    }

    greenisland_recorder_manager::greenisland_recorder_manager()
        : m_greenisland_recorder_manager(0)
    {
    }

    greenisland_recorder_manager::~greenisland_recorder_manager()
    {
    }

    void greenisland_recorder_manager::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_recorder_manager = static_cast<struct ::greenisland_recorder_manager *>(wl_registry_bind(registry, id, &greenisland_recorder_manager_interface, version));
    }

    void greenisland_recorder_manager::init(struct ::greenisland_recorder_manager *obj)
    {
        m_greenisland_recorder_manager = obj;
    }

    bool greenisland_recorder_manager::isInitialized() const
    {
        return m_greenisland_recorder_manager != 0;
    }

    struct ::greenisland_recorder *greenisland_recorder_manager::create_recorder(struct ::wl_output *output)
    {
        return greenisland_recorder_manager_create_recorder(
            m_greenisland_recorder_manager,
            output);
    }

    greenisland_recorder::greenisland_recorder(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_recorder::greenisland_recorder(struct ::greenisland_recorder *obj)
        : m_greenisland_recorder(obj)
    {
        init_listener();
    }

    greenisland_recorder::greenisland_recorder()
        : m_greenisland_recorder(0)
    {
    }

    greenisland_recorder::~greenisland_recorder()
    {
    }

    void greenisland_recorder::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_recorder = static_cast<struct ::greenisland_recorder *>(wl_registry_bind(registry, id, &greenisland_recorder_interface, version));
        init_listener();
    }

    void greenisland_recorder::init(struct ::greenisland_recorder *obj)
    {
        m_greenisland_recorder = obj;
        init_listener();
    }

    bool greenisland_recorder::isInitialized() const
    {
        return m_greenisland_recorder != 0;
    }

    void greenisland_recorder::destroy()
    {
        greenisland_recorder_destroy(
            m_greenisland_recorder);
        m_greenisland_recorder = 0;
    }

    void greenisland_recorder::record_frame(struct ::wl_buffer *buffer)
    {
        greenisland_recorder_record_frame(
            m_greenisland_recorder,
            buffer);
    }

    void greenisland_recorder::repaint()
    {
        greenisland_recorder_repaint(
            m_greenisland_recorder);
    }

    void greenisland_recorder::recorder_setup(int32_t , int32_t , int32_t , int32_t )
    {
    }

    void greenisland_recorder::handle_setup(
        void *data,
        struct ::greenisland_recorder *object,
        int32_t width,
        int32_t height,
        int32_t stride,
        int32_t format)
    {
        Q_UNUSED(object);
        static_cast<greenisland_recorder *>(data)->recorder_setup(
            width,
            height,
            stride,
            format);
    }

    void greenisland_recorder::recorder_frame(struct ::wl_buffer *, uint32_t , int32_t )
    {
    }

    void greenisland_recorder::handle_frame(
        void *data,
        struct ::greenisland_recorder *object,
        struct ::wl_buffer *buffer,
        uint32_t time,
        int32_t transform)
    {
        Q_UNUSED(object);
        static_cast<greenisland_recorder *>(data)->recorder_frame(
            buffer,
            time,
            transform);
    }

    void greenisland_recorder::recorder_failed(int32_t , struct ::wl_buffer *)
    {
    }

    void greenisland_recorder::handle_failed(
        void *data,
        struct ::greenisland_recorder *object,
        int32_t result,
        struct ::wl_buffer *buffer)
    {
        Q_UNUSED(object);
        static_cast<greenisland_recorder *>(data)->recorder_failed(
            result,
            buffer);
    }

    void greenisland_recorder::recorder_cancelled(struct ::wl_buffer *)
    {
    }

    void greenisland_recorder::handle_cancelled(
        void *data,
        struct ::greenisland_recorder *object,
        struct ::wl_buffer *buffer)
    {
        Q_UNUSED(object);
        static_cast<greenisland_recorder *>(data)->recorder_cancelled(
            buffer);
    }

    const struct greenisland_recorder_listener greenisland_recorder::m_greenisland_recorder_listener = {
        greenisland_recorder::handle_setup,
        greenisland_recorder::handle_frame,
        greenisland_recorder::handle_failed,
        greenisland_recorder::handle_cancelled
    };

    void greenisland_recorder::init_listener()
    {
        greenisland_recorder_add_listener(m_greenisland_recorder, &m_greenisland_recorder_listener, this);
    }
}

QT_END_NAMESPACE
