/****************************************************************************
 * This file is part of Green Island.
 *
 * Copyright (C) 2015 Pier Luigi Fiorini <pierluigi.fiorini@gmail.com>
 *
 * Author(s):
 *    Pier Luigi Fiorini
 *
 * $BEGIN_LICENSE:LGPL2.1+$
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $END_LICENSE$
 ***************************************************************************/

#ifndef APPLICATIONMANAGER_P_H
#define APPLICATIONMANAGER_P_H

#include <QtCore/QHash>
#include <QtCore/QSet>

//  W A R N I N G
//  -------------
//
// This file is not part of the Green Island API.  It exists purely as an
// implementation detail.  This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.

class QWaylandSurface;

namespace GreenIsland {

class ApplicationManager;

class ApplicationManagerPrivate
{
    Q_DECLARE_PUBLIC(ApplicationManager)
public:
    ApplicationManagerPrivate(ApplicationManager *parent);

    void registerSurface(QWaylandSurface *surface, const QString &appId);
    void unregisterSurface(QWaylandSurface *surface, const QString &appId);

    QHash<QString, QList<QWaylandSurface *> > surfaces;
    QHash<QWaylandSurface *, pid_t> surfacePids;

protected:
    ApplicationManager *q_ptr;
};

}

#endif // APPLICATIONMANAGER_P_H

